clear all

program define Descfile
    syntax using/, book(string)
    
    qui use "`using'", clear
    
    if `"`: data label'"' != "" {
        file write `book' `"<h2>`:data label'</h2>"' _n
    }
    if "`: char _dta[note0]'" != "" {
        file write `book' "<h3>Notes:</h3>"_n"<ul>"_n
        forvalues i = 1/`: char _dta[note0]' {
            file write `book' `"<li>`: char _dta[note`i']'</li>"' _n
        }
        file write `book' "</ul>"_n
    }
end

program define Descvars                                  //new
    syntax, book(string)                                 //new
                                                         //new
    file write `book' "<h3>Variable list</h3>"_n         //new
    file write `book' "<ul>"_n                           //new
    foreach var of varlist * {                           //new
        file write `book' "<li>`var'"                    //new
        if `"`: var label `var''"' != "`var'" {          //new
            file write `book' `": `: var label `var''"'  //new
        }                                                //new
        file write `book' "</li>"_n                      //new
    }                                                    //new
    file write `book' "</ul>"                            //new
end                                                         //new

program define htmlcodebook
    version 14
    syntax using/ , SAVing(string) [replace title(string)]
    
    tempname book 
    file open `book' using `saving', write `replace'
    preserve
    
    file write `book' "<!DOCTYPE html>"_n"<html>"_n
    file write `book' "<style>"_n
    file write `book' "body {"_n
    file write `book' "width: 650px;"_n
    file write `book' "margin: auto;"_n
    file write `book' "}"_n
    file write `book' "</style>"_n    
    if `"`title'"' != "" {
        file write `book' "<h1>`title'</h1>"_n
    }
    else {
        file write `book' "<h1>Codebook for `using'</h1>"_n
    }
    
    Descfile using "`using'", book(`book')
    Descvars, book(`book')                               //new
    
    file write `book' "</html>"_n
    file close `book'
    di as txt "Output written to " `"{browse "`saving'"}"'        
    restore
end

cd h:\stata_l2
htmlcodebook using arc06.dta, saving(test.html) replace

